#ifndef __GPOD_TRACKER_H__
#define __GPOD_TRACKER_H__

#include <tracker-sparql.h>

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define GPOD_TYPE_TRACKER (gpod_tracker_get_type ())

G_DECLARE_FINAL_TYPE (GpodTracker, gpod_tracker, GPOD, TRACKER, GObject)

typedef struct _GpodTrackerQuery
{
    GCancellable *cancellable;
    gpointer      user_data;
} GpodTrackerQuery;

GpodTracker *
gpod_tracker_new ();

gboolean
gpod_tracker_check_database (GpodTracker *self);

void
gpod_tracker_connection_init (GpodTracker  *self,
                              GCancellable *cancellable);

void
gpod_tracker_query_update_full (GpodTracker         *self,
                                gchar               *query,
                                GCancellable        *cancellable,
                                GAsyncReadyCallback  callback);

void
gpod_tracker_query_update (GpodTracker  *self,
                           gchar        *query,
                           GCancellable *cancellable);

gboolean
gpod_tracker_query_cursor_finish (TrackerSparqlCursor  *cursor,
                                  GAsyncResult         *result,
                                  GError              **error);

void
gpod_tracker_query_cursor_next (TrackerSparqlCursor *cursor,
                                GCancellable        *cancellable,
                                GAsyncReadyCallback  callback,
                                gpointer             user_data);

TrackerSparqlCursor *
gpod_tracker_query_finish (TrackerSparqlConnection  *connection,
                           GAsyncResult             *result,
                           gpointer                  user_data,
                           GError                  **error);

void
gpod_tracker_query (GpodTracker         *self,
                    gchar               *query,
                    GCancellable        *cancellable,
                    GAsyncReadyCallback  callback,
                    gpointer             user_data);

G_END_DECLS

#endif /* __GPOD_TRACKER_H__ */
